<?php
declare(strict_types=1);

use Migrations\AbstractMigration;

class Patch220 extends AbstractMigration
{
    public function up()
    {
        $table = $this->table('org_entities');
        $table->removeColumn('archival_agency_id');
        $table->update();

        $table = $this->table('org_entities');
        $table->removeColumn('default_secure_data_space_id')
            ->update();

        $table = $this->table('transfers');
        $table->addColumn(
            'hidden',
            'boolean',
            [
                'default' => false,
                'null' => false,
            ]
        );
        $table->update();

        $table = $this->table('transfers');
        $table->addColumn(
            'originating_agency_id',
            'integer',
            [
                'default' => null,
                'limit' => 11,
                'null' => true,
            ]
        );
        $table->update();

        $table->changeColumn(
            'originating_agency_id',
            'integer',
            [
                'default' => null,
                'limit' => 11,
                'null' => false,
            ]
        );
        $table->addForeignKey(
            'originating_agency_id',
            'org_entities',
            'id',
            ['update' => 'CASCADE']
        );
        $table->update();

        $table = $this->table('archives');
        $table->removeColumn('transfer_id');
        $table->update();

        $table = $this->table('users');
        $table->addColumn(
            'notify_download_pdf_frequency',
            'integer',
            [
                'default' => 1,
                'limit' => 11,
                'null' => true,
            ]
        );
        $table->addColumn(
            'notify_download_zip_frequency',
            'integer',
            [
                'default' => 1,
                'limit' => 11,
                'null' => true,
            ]
        );
        $table->addColumn(
            'notify_validation_frequency',
            'integer',
            [
                'default' => null,
                'limit' => 11,
                'null' => true,
            ]
        );
        $table->addColumn(
            'notify_job_frequency',
            'integer',
            [
                'default' => null,
                'limit' => 11,
                'null' => true,
            ]
        );
        $table->addColumn(
            'notify_agreement_frequency',
            'integer',
            [
                'default' => null,
                'limit' => 11,
                'null' => true,
            ]
        );
        $table->addColumn(
            'notify_transfer_report_frequency',
            'integer',
            [
                'default' => null,
                'limit' => 11,
                'null' => true,
            ]
        );
        $table->update();

        $table = $this->table('agreements');
        $table->addColumn(
            'notify_delay',
            'integer',
            [
                'default' => 0,
                'limit' => 11,
                'null' => false,
            ]
        );
        $table->update();

        $table = $this->table('beanstalk_jobs');
        $table->addColumn(
            'data',
            'binary',
            [
                'default' => null,
                'null' => true,
            ]
        );
        $table->update();

        $table = $this->table('beanstalk_jobs');
        $table->removeColumn('jobid');
        $table->removeColumn('last_status');
        $table->update();

        $table = $this->table('beanstalk_jobs');
        $table->addColumn(
            'beanstalk_worker_id',
            'integer',
            [
                'default' => null,
                'limit' => 11,
                'null' => true,
            ]
        );
        $table->addColumn(
            'object_model',
            'string',
            [
                'default' => null,
                'limit' => 255,
                'null' => true,
            ]
        );
        $table->addColumn(
            'object_foreign_key',
            'integer',
            [
                'default' => null,
                'limit' => 11,
                'null' => true,
            ]
        );
        $table->addColumn(
            'job_state',
            'string',
            [
                'default' => null,
                'limit' => 255,
                'null' => true,
            ]
        );
        $table->addColumn(
            'last_state_update',
            'datetime',
            [
                'default' => null,
                'null' => true,
            ]
        );
        $table->addColumn(
            'states_history',
            'text',
            [
                'default' => null,
                'null' => true,
            ]
        );
        $table->addForeignKey(
            'beanstalk_worker_id',
            'beanstalk_workers',
            'id',
            [
                'update' => 'CASCADE',
                'delete' => 'SET NULL'
            ]
        );
        $table->update();
    }
}
